{{- if .Values.app.secrets }}
apiVersion: v1
kind: Secret
metadata:
  name: {{ .Release.Name }}-secret
data:
  {{- range $key, $value := .Values.app.secrets }}
  {{ $key }}: {{ $value | b64enc }}
  {{- end }}
{{- end }}
---
{{- if .Values.imagePullSecret }}
# Construct the config object
{{- $registry := dict }}
{{- $_ := set $registry "username" .Values.imagePullSecret.username }}
{{- $_ := set $registry "password" .Values.imagePullSecret.password }}
{{- $auth := printf "%s:%s" $registry.username $registry.password | b64enc }}
{{- $_ := set $registry "auth" $auth }}
{{- $auths := dict .Values.imagePullSecret.registry $registry }}
{{- $config := dict "auths" $auths }}

apiVersion: v1
kind: Secret
metadata:
  name: {{ .Release.Name }}-pullsecret
data:
  .dockerconfigjson: {{ $config | toJson | b64enc | quote }}
type: kubernetes.io/dockerconfigjson
{{- end }}
